import 'package:aliyun_player_fluttify/aliyun_player_fluttify.dart';
import 'package:flutter/material.dart';
import 'package:oktoast/oktoast.dart';
import 'package:permission_handler/permission_handler.dart';

void main() async {
  WidgetsFlutterBinding.ensureInitialized();

  await Permission.camera.request();

  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  @override
  Widget build(BuildContext context) {
    return OKToast(
      child: MaterialApp(
        home: Scaffold(
          appBar: AppBar(title: const Text('Plugin example app')),
          body: FutureBuilder<AliPlayer>(
            future: AliPlayer.create(),
            builder: (context, snapshot) {
              if (snapshot.hasData) {
                final player = snapshot.data;
                return AliPlayerView(
                  player: player,
                  onViewCreated: (controller) async {
                    await player.setDataSource(UrlSource(
                        'https://stream7.iqilu.com/10339/upload_transcode/202002/17/20200217104524H4D6lmByOe.mp4'));
                    await player.prepare();
                    await player.start();
                  },
                );
              } else {
                return Center(child: CircularProgressIndicator());
              }
            },
          ),
        ),
      ),
    );
  }
}
