part of aliyun_player_fluttify;

enum MirrorMode { none, horizontal, vertical }

enum RotateMode { ROTATE_0, ROTATE_90, ROTATE_180, ROTATE_270 }

enum ScaleMode {
  // 宽高比适应（将按照视频宽高比等比缩小到view内部，不会有画面变形）
  ASPECT_FIT,
  // 宽高比填充（将按照视频宽高比等比放大，充满view，不会有画面变形）
  ASPECT_FILL,
  // 拉伸填充（如果视频宽高比例与view比例不一致，会导致画面变形）
  TO_FILL,
}

enum ErrorCode {
  ERROR_SERVER_NO_RESPONSE ,
  ERROR_SERVER_WRONG_JSON ,
  ERROR_NO_MATCH_QUALITY ,
  ERROR_PLAYAUTH_WRONG ,
  ERROR_REQUEST_FAIL ,
  ERROR_NO_PLAY_INFO ,
  ERROR_SERVER_POP_UNKNOWN ,
  ERROR_SERVER_POP_MISSING_PARAMETER ,
  ERROR_SERVER_POP_INVALID_PARAMETER ,
  ERROR_SERVER_POP_OPERATION_DENIED ,
  ERROR_SERVER_POP_OPERATION_SUSPENED ,
  ERROR_SERVER_POP_FORBIDDEN ,
  ERROR_SERVER_POP_INTERNAL_ERROR ,
  ERROR_SERVER_POP_SERVICE_UNAVALIABLE ,
  ERROR_SERVER_POP_SIGNATUREANONCE_USED ,
  ERROR_SERVER_POP_SECURITYTOKEN_MAILFORMED ,
  ERROR_SERVER_POP_SECURITYTOKEN_MISMATCH_ACCESSKEY ,
  ERROR_SERVER_POP_SIGNATURE_NOT_MATCH ,
  ERROR_SERVER_POP_ACCESSKEYID_NOT_FOUND ,
  ERROR_SERVER_POP_TOKEN_EXPIRED ,
  ERROR_SERVER_VOD_UNKNOWN ,
  ERROR_SERVER_VOD_FORBIDDEN_ILLEGALSTATUS ,
  ERROR_SERVER_VOD_INVALIDVIDEO_NOTFOUND ,
  ERROR_SERVER_VOD_INVALIDVIDEO_NOSTREAM ,
  ERROR_SERVER_VOD_FORBIDDEN_ALIYUNVODENCRYPTION ,
  ERROR_SERVER_VOD_INVALIDAUTH_MEDIAID ,
  ERROR_SERVER_VOD_INVALIDAUTHINFO_EXPIRETIME ,
  ERROR_SERVER_MPS_UNKNOWN ,
  ERROR_SERVER_MPS_INVALID_MEDIAID ,
  ERROR_SERVER_MPS_INVALID_AUTHTIMEOUT ,
  ERROR_SERVER_MPS_INVALID_FORMATS ,
  ERROR_SERVER_MPS_INVALID_AUTHINFO ,
  ERROR_SERVER_MPS_SIGNATURE_CHECK_FAILED ,
  ERROR_SERVER_MPS_MEDIAID_NOT_EXIST ,
  ERROR_SERVER_MPS_MEDIA_RESOURCE_NOT_EXIST ,
  ERROR_SERVER_MPS_MEDIA_NOT_PUBLISHED ,
  ERROR_SERVER_MPS_MEDIA_NOT_ENCRYPTED ,
  ERROR_SERVER_MPS_INVALID_CIPHERTEXTBLOB ,
  ERROR_SERVER_MPS_CIPHERBLOB_NOT_EXIST ,
  ERROR_SERVER_MPS_INTERNAL_ERROR ,
  ERROR_SERVER_MPS_INVALID_IDENTITY_NOT_ORDER_VIDEO_SERVICE ,
  ERROR_SERVER_MPS_UPDATE_CDN_DOMAIN_CONFIGS_FAIL ,
  ERROR_SERVER_MPS_AUTH_KEY_EXIST ,
  ERROR_SERVER_MPS_AUTH_KEY_NOT_EXIST ,
  ERROR_SERVER_MPS_INVALID_PARAMETER_OUT_OF_BOUND ,
  ERROR_SERVER_MPS_INVALID_PARAMETER ,
  ERROR_SERVER_MPS_INVALID_PARAMETER_NULL_VALUE ,
  ERROR_SERVER_MPS_INVALID_PARAMETER_EMPTY_VALUE ,
  ERROR_SERVER_MPS_MEDIA_RESOURCE_NOT_MATCH ,
  ERROR_SERVER_MPS_MEDIA_NOT_FOUND_CIPHERTEXT ,
  ERROR_SERVER_MPS_INVALID_PARAMETER_RAND ,
  ERROR_SERVER_MPS_REDIS_POOL_IS_EMPTY ,
  ERROR_SERVER_MPS_SIGNATURE_CHECK_MEDIA_FAILED ,
  ERROR_SERVER_MPS_SIGNATURE_CHECK_EXPIREDTIME_FAILED ,
  ERROR_SERVER_MPS_INVALID_SESSION_TIME ,
  ERROR_SERVER_MPS_INVALID_END_USER_ID ,
  ERROR_SERVER_MPS_INVALID_URL ,
  ERROR_SERVER_MPS_HTTP_REQUEST_FAILED ,
  ERROR_SERVER_MPS_XML_FORMAT_ERROR ,
  ERROR_SERVER_MPS_SESSION_NOT_EXIST ,
  ERROR_SERVER_MPS_REGION_NOT_SUPPORTED_API ,
  ERROR_SERVER_MPS_DRM_NOT_ACTIVATED ,
  ERROR_SERVER_MPS_DRM_AUTH_ERROR ,
  ERROR_SERVER_MPS_CDN_CONFIG_NOT_EXIST ,
  ERROR_SERVER_LIVESHIFT_UNKNOWN ,
  ERROR_SERVER_LIVESHIFT_REQUEST_ERROR ,
  ERROR_SERVER_LIVESHIFT_DATA_PARSER_ERROR ,
  ERROR_KEYMANAGER_UNKNOWN ,
  ERROR_TBDRM_UNKNOWN ,
  ERROR_TBDRM_DEMUXER_UNIMPLEMENTED ,
  ERROR_ARTP_UNKNOWN ,
  ERROR_ARTP_DEMUXER_UNIMPLEMENTED ,
  ERROR_ARTP_LOAD_FAILED ,
  ERROR_ARTP_STREAM_ILLEGAL ,
  ERROR_ARTP_STREAM_FORBIDDEN ,
  ERROR_ARTP_STREAM_NOT_FOUND ,
  ERROR_ARTP_STREAM_STOPPED ,
  ERROR_ARTP_PLAY_TIMEOUT ,
  ERROR_ARTP_SPSPPS_AACCONF_TIMEOUT ,
  ERROR_ARTP_ARTP_MEDIA_INFO_TIMEOUT ,
  ERROR_ARTP_PACKET_RECV_TIMEOUT ,
  ERROR_ARTP_MEDIA_PROBE_FAILED ,
  ERROR_UNKNOWN_ERROR ,
  ERROR_DEMUXER_START ,
  ERROR_DEMUXER_OPENURL ,
  ERROR_DEMUXER_NO_VALID_STREAM ,
  ERROR_DEMUXER_OPENSTREAM ,
  ERROR_LOADING_TIMEOUT ,
  ERROR_DATASOURCE_EMPTYURL ,
  ERROR_DECODE_BASE ,
  ERROR_DECODE_VIDEO ,
  ERROR_DECODE_AUDIO ,
  ERROR_NETWORK_UNKNOWN ,
  ERROR_NETWORK_UNSUPPORTED ,
  ERROR_NETWORK_RESOLVE ,
  ERROR_NETWORK_CONNECT_TIMEOUT ,
  ERROR_NETWORK_COULD_NOT_CONNECT ,
  ERROR_NETWORK_HTTP_403 ,
  ERROR_NETWORK_HTTP_404 ,
  ERROR_NETWORK_HTTP_4XX ,
  ERROR_NETWORK_HTTP_5XX ,
  ERROR_NETWORK_HTTP_RANGE ,
  ERROR_NETWORK_HTTP_400 ,
  ERROR_CODEC_UNKNOWN ,
  ERROR_CODEC_VIDEO_NOT_SUPPORT ,
  ERROR_CODEC_AUDIO_NOT_SUPPORT ,
  ERROR_INERNAL_UNKNOWN ,
  ERROR_INERNAL_EXIT ,
  ERROR_GENERAL_UNKNOWN ,
  ERROR_GENERAL_EPERM ,
  ERROR_GENERAL_ENOENT ,
  ERROR_GENERAL_EIO ,
  ERROR_PLAYER_UNKNOWN ,
  DOWNLOADER_ERROR_NOT_SELECT_ITEM ,
  DOWNLOADER_ERROR_NO_DOWNLOAD_ITEM ,
  DOWNLOADER_ERROR_STS_SOURCE_NULL ,
  DOWNLOADER_ERROR_AUTH_SOURCE_NULL ,
  DOWNLOADER_ERROR_AUTH_SOURCE_WRONG ,
  DOWNLOADER_ERROR_INVALID_ITEM ,
  DOWNLOADER_ERROR_URL_CANNOT_REACH ,
  DOWNLOADER_ERROR_NOT_SUPPORT_FORMAT ,
  DOWNLOADER_ERROR_ENCRYPT_FILE_NOT_MATCH ,
  DOWNLOADER_ERROR_DOWNLOAD_SWITCH_OFF ,
  DOWNLOADER_ERROR_NET_ERROR ,
  DOWNLOADER_ERROR_NOT_SET_SAVE_DIR ,
  DOWNLOADER_ERROR_CANNOT_CREATE_SAVE_DIR ,
  DOWNLOADER_ERROR_NO_SPACE ,
  DOWNLOADER_ERROR_WRITE_ERROR ,
  DOWNLOADER_ERROR_ENCRYPT_ERROR ,
  DOWNLOADER_ERROR_FILE_NOT_EXIST ,
  DOWNLOADER_ERROR_CLEAN_INVALID_PARAM ,
  DOWNLOADER_ERROR_CLEAN_WRONG_STATUS ,
  DOWNLOADER_ERROR_GET_AES_KEY_FAIL ,
  DOWNLOADER_ERROR_ENCRYPTION_NOT_SUPPORT ,
}


extension MirrorModeX on MirrorMode {
  com_aliyun_player_IPlayer_MirrorMode toAndroidModel() {
    switch (this) {
      case MirrorMode.none:
        return com_aliyun_player_IPlayer_MirrorMode.MIRROR_MODE_NONE;
      case MirrorMode.horizontal:
        return com_aliyun_player_IPlayer_MirrorMode.MIRROR_MODE_HORIZONTAL;
      case MirrorMode.vertical:
        return com_aliyun_player_IPlayer_MirrorMode.MIRROR_MODE_VERTICAL;
      default:
        return com_aliyun_player_IPlayer_MirrorMode.MIRROR_MODE_NONE;
    }
  }

  AVPMirrorMode toIOSModel() {
    switch (this) {
      case MirrorMode.none:
        return AVPMirrorMode.AVP_MIRRORMODE_NONE;
      case MirrorMode.horizontal:
        return AVPMirrorMode.AVP_MIRRORMODE_HORIZONTAL;
      case MirrorMode.vertical:
        return AVPMirrorMode.AVP_MIRRORMODE_VERTICAL;
      default:
        return AVPMirrorMode.AVP_MIRRORMODE_NONE;
    }
  }
}

extension RotateModeX on RotateMode {
  com_aliyun_player_IPlayer_RotateMode toAndroidModel() {
    switch (this) {
      case RotateMode.ROTATE_0:
        return com_aliyun_player_IPlayer_RotateMode.ROTATE_0;
      case RotateMode.ROTATE_90:
        return com_aliyun_player_IPlayer_RotateMode.ROTATE_90;
      case RotateMode.ROTATE_180:
        return com_aliyun_player_IPlayer_RotateMode.ROTATE_180;
      case RotateMode.ROTATE_270:
        return com_aliyun_player_IPlayer_RotateMode.ROTATE_270;
      default:
        return com_aliyun_player_IPlayer_RotateMode.ROTATE_0;
    }
  }

  AVPRotateMode toIOSModel() {
    switch (this) {
      case RotateMode.ROTATE_0:
        return AVPRotateMode.AVP_ROTATE_0;
      case RotateMode.ROTATE_90:
        return AVPRotateMode.AVP_ROTATE_90;
      case RotateMode.ROTATE_180:
        return AVPRotateMode.AVP_ROTATE_180;
      case RotateMode.ROTATE_270:
        return AVPRotateMode.AVP_ROTATE_270;
      default:
        return AVPRotateMode.AVP_ROTATE_0;
    }
  }
}

extension ScaleModeX on ScaleMode {
  com_aliyun_player_IPlayer_ScaleMode toAndroidModel() {
    switch (this) {
      case ScaleMode.ASPECT_FIT:
        return com_aliyun_player_IPlayer_ScaleMode.SCALE_ASPECT_FIT;
      case ScaleMode.ASPECT_FILL:
        return com_aliyun_player_IPlayer_ScaleMode.SCALE_ASPECT_FILL;
      case ScaleMode.TO_FILL:
        return com_aliyun_player_IPlayer_ScaleMode.SCALE_TO_FILL;
      default:
        return com_aliyun_player_IPlayer_ScaleMode.SCALE_ASPECT_FIT;
    }
  }

  AVPScalingMode toIOSModel() {
    switch (this) {
      case ScaleMode.ASPECT_FIT:
        return AVPScalingMode.AVP_SCALINGMODE_SCALEASPECTFIT;
      case ScaleMode.ASPECT_FILL:
        return AVPScalingMode.AVP_SCALINGMODE_SCALEASPECTFILL;
      case ScaleMode.TO_FILL:
        return AVPScalingMode.AVP_SCALINGMODE_SCALETOFILL;
      default:
        return AVPScalingMode.AVP_SCALINGMODE_SCALEASPECTFIT;
    }
  }
}
