part of aliyun_player_fluttify;

class PrivateService {
  static PrivateService instance = PrivateService._();

  PrivateService._();

  /// 配置加解密key
  ///
  /// 如果播放的视频是通过播放器SDK安全下载后的本地文件，需要设置一个加密校验信息（建议在Application中配置一次即可）
  Future<void> initPrivateKey(String keyPath) async {
    return platform(
      android: (pool) async {
        final context = await android_app_Application.get();
        await com_aliyun_private_service_PrivateService.initService(
            context, keyPath);
      },
      ios: (pool) async {
        await ios.AliPrivateService.initKey(keyPath);
      },
    );
  }
}
